.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include   include\windows.inc
include   include\user32.inc
include   include\kernel32.inc
include   include\comctl32.inc
include   include\comdlg32.inc
include   include\shell32.inc
include   include\gdi32.inc 
include   include\msvcrt.inc

includelib   lib\user32.lib
includelib   lib\kernel32.lib
includelib   lib\comctl32.lib
includelib   lib\comdlg32.lib
includelib   lib\shell32.lib
includelib   lib\gdi32.lib
includelib   lib\msvcrt.lib
include  include\macros.asm
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
IDC_EXIT      equ 102
IDC_STC1      equ 103



; Required data

.data
szTitle       TCHAR "TEST Edit Box window", 0



.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
hBrush1    dd ?
hBrush2    dd ?
.code

start:

INVOKE GetModuleHandle, NULL
mov hInstance, eax
invoke InitCommonControls
INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM


local pt:POINT
invoke GetCursorPos,addr pt
invoke Sleep,1000
invoke SetCursorPos,addr pt.x,addr pt.y

mov		eax,uMsg
 .IF eax == WM_INITDIALOG

  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
 
    .ELSEIF eax == WM_COMMAND
    
.elseif eax==WM_CTLCOLORSTATIC
		invoke GetWindowLong,lParam,GWL_ID
		.if eax==103		
			.if hBrush2
		  		invoke DeleteObject,hBrush2
			.endif
			invoke SetBkMode,wParam,TRANSPARENT
			invoke SetTextColor,wParam,00FF0000h	;foreground
			invoke CreateSolidBrush,00EDE9EBh		; same as our back background so we do not color the whole static
			mov		hBrush2,eax
			ret
		.endif
			mov eax,FALSE
			ret

push 0
push sdword$(pt.x)
push sdword$(pt.y)
push 0
.elseif eax==103
.elseif eax==WM_CTLCOLORSTATIC
		invoke GetWindowLong,lParam,GWL_ID
		.if eax==103		
			.if hBrush1
		  		invoke DeleteObject,hBrush1
			.endif
			invoke SetBkMode,wParam,TRANSPARENT
			invoke SetTextColor,wParam,000000FFh	;foreground
			invoke CreateSolidBrush,00EDE9EBh		; same as our back background so we do not color the whole static
			mov		hBrush1,eax
			ret
		.endif
			mov eax,FALSE
			ret
  	.elseif eax == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

   
		  
 	.if wParam == IDC_EXIT 
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
  .ENDIF	
 

    xor eax,eax
  ret
DialogProc endp

end start